

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.learn.nn package &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="index.html"/> 

  
  <script src="_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          

 



<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="index.html">Docs</a> &raquo;</li>
      
    <li>d2o.learn.nn package</li>
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="_sources/d2o.learn.nn.txt" rel="nofollow"> View page source</a>
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="d2o-learn-nn-package">
<h1>d2o.learn.nn package<a class="headerlink" href="#d2o-learn-nn-package" title="Permalink to this headline">¶</a></h1>
<div class="section" id="submodules">
<h2>Submodules<a class="headerlink" href="#submodules" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="module-d2o.learn.nn.bpn">
<span id="d2o-learn-nn-bpn-module"></span><h2>d2o.learn.nn.bpn module<a class="headerlink" href="#module-d2o.learn.nn.bpn" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.learn.nn.bpn.BackpropagationNetwork">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.bpn.</code><code class="descname">BackpropagationNetwork</code><span class="sig-paren">(</span><em>input_mask</em>, <em>target_mask</em>, <em>num_hidden=1</em>, <em>zero_band=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/bpn.html#BackpropagationNetwork"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.bpn.BackpropagationNetwork" title="Permalink to this definition">¶</a></dt>
<dd><p>Simple Neural network utilizing the back propagation (error-propagation) method.
TODO: Can be replaced by MXNET, Tensorflow, Caffe etc.</p>
<dl class="method">
<dt id="d2o.learn.nn.bpn.BackpropagationNetwork.run">
<code class="descname">run</code><span class="sig-paren">(</span><em>inputs</em>, <em>inverse_transform=True</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/bpn.html#BackpropagationNetwork.run"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.bpn.BackpropagationNetwork.run" title="Permalink to this definition">¶</a></dt>
<dd><p>Runs the neural network on inputs and return results.
:param inputs: Input vector
:param iverse_transform: Inversely apply the dataset scaler on the results (upscale)
:returns:       Result vector</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.bpn.BackpropagationNetwork.shake_weights">
<code class="descname">shake_weights</code><span class="sig-paren">(</span><em>amount=0.1</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/bpn.html#BackpropagationNetwork.shake_weights"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.bpn.BackpropagationNetwork.shake_weights" title="Permalink to this definition">¶</a></dt>
<dd><p>Shake weights (randomization). Deprecated
:param amount: How much the weights should be shifted, coefficient
:returns:       None</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.bpn.BackpropagationNetwork.train">
<code class="descname">train</code><span class="sig-paren">(</span><em>dataset</em>, <em>learning_rate=0.2</em>, <em>momentum=0.5</em>, <em>epochs=1000000</em>, <em>min_err=0.001</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/bpn.html#BackpropagationNetwork.train"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.bpn.BackpropagationNetwork.train" title="Permalink to this definition">¶</a></dt>
<dd><p>Train the network over several epochs.
:param dataset: Dataset which fits the network blueprint
:param learning_rate: Network learning rate
:param momentum: Learning momentum
:param epochs: Max number of epochs to train for
:param min_err: Termination error
:returns:       Numpy array of errors per epoch</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.bpn.BackpropagationNetwork.train_epoch">
<code class="descname">train_epoch</code><span class="sig-paren">(</span><em>dataset</em>, <em>learning_rate=0.2</em>, <em>momentum=0.5</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/bpn.html#BackpropagationNetwork.train_epoch"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.bpn.BackpropagationNetwork.train_epoch" title="Permalink to this definition">¶</a></dt>
<dd><p>Train the network for one epoch.
:param dataset: Dataset which fits the network blueprint
:param learning_rate: Network learning rate
:param momentum: Learning momentum
:returns:         Error for this epoch</p>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn.d2o_mask_factory">
<span id="d2o-learn-nn-d2o-mask-factory-module"></span><h2>d2o.learn.nn.d2o_mask_factory module<a class="headerlink" href="#module-d2o.learn.nn.d2o_mask_factory" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.learn.nn.d2o_mask_factory.d2oMaskFactory">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.d2o_mask_factory.</code><code class="descname">d2oMaskFactory</code><span class="sig-paren">(</span><em>df</em>, <em>target_mask</em>, <em>cutoff=None</em>, <em>req_cols=[]</em>, <em>forecasting_cols=[]</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/d2o_mask_factory.html#d2oMaskFactory"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.d2o_mask_factory.d2oMaskFactory" title="Permalink to this definition">¶</a></dt>
<dd><p>Mask generator designed based on results from research on d2o timeseries</p>
<dl class="method">
<dt id="d2o.learn.nn.d2o_mask_factory.d2oMaskFactory.input_mask">
<code class="descname">input_mask</code><span class="sig-paren">(</span><em>padding=1</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/d2o_mask_factory.html#d2oMaskFactory.input_mask"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.d2o_mask_factory.d2oMaskFactory.input_mask" title="Permalink to this definition">¶</a></dt>
<dd><dl class="docutils">
<dt>The logic is as follows:</dt>
<dd>For index i (in the dataframe); The input_mask = [i, i-t1, i-t2, ..., i-tn]
Where t is an element in the the target_mask</dd>
<dt>NOTE: In addition to this we manually add a few lag periods (i-t&#8217;s)</dt>
<dd><ol class="first last arabic simple">
<li>We manually add i-365.</li>
<li>The columns [&#8216;Total_RN&#8217;, &#8216;Total_RV&#8217;] are added to the input mask, with the same
lags as the target variable</li>
<li>Padding is added to include more data around the relevant lag periods</li>
</ol>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn.datasets">
<span id="d2o-learn-nn-datasets-module"></span><h2>d2o.learn.nn.datasets module<a class="headerlink" href="#module-d2o.learn.nn.datasets" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.learn.nn.datasets.Dataset">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.datasets.</code><code class="descname">Dataset</code><span class="sig-paren">(</span><em>df</em>, <em>input_mask</em>, <em>target_mask</em>, <em>training_percentage=0.8</em>, <em>name='Unnamed'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset" title="Permalink to this definition">¶</a></dt>
<dd><p>Dataset designed for use in Neural Networks.
Splits into training and target sets and contains methods for
scaling input to transfer function ranges.</p>
<dl class="method">
<dt id="d2o.learn.nn.datasets.Dataset.input_size">
<code class="descname">input_size</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset.input_size"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset.input_size" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.datasets.Dataset.output_size">
<code class="descname">output_size</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset.output_size"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset.output_size" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.datasets.Dataset.test_inputs">
<code class="descname">test_inputs</code><span class="sig-paren">(</span><em>limit=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset.test_inputs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset.test_inputs" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.datasets.Dataset.test_targets">
<code class="descname">test_targets</code><span class="sig-paren">(</span><em>limit=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset.test_targets"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset.test_targets" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.datasets.Dataset.training_inputs">
<code class="descname">training_inputs</code><span class="sig-paren">(</span><em>limit=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset.training_inputs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset.training_inputs" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.datasets.Dataset.training_targets">
<code class="descname">training_targets</code><span class="sig-paren">(</span><em>limit=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset.training_targets"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset.training_targets" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.datasets.Dataset.validate">
<code class="descname">validate</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/datasets.html#Dataset.validate"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.datasets.Dataset.validate" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn.maskfactory">
<span id="d2o-learn-nn-maskfactory-module"></span><h2>d2o.learn.nn.maskfactory module<a class="headerlink" href="#module-d2o.learn.nn.maskfactory" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.learn.nn.maskfactory.MaskFactory">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.maskfactory.</code><code class="descname">MaskFactory</code><a class="reference internal" href="_modules/d2o/learn/nn/maskfactory.html#MaskFactory"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.maskfactory.MaskFactory" title="Permalink to this definition">¶</a></dt>
<dd><p>Analyses a data frame and an output mask, then decides on a suitable
input frame to use in time series predication.</p>
<dl class="method">
<dt id="d2o.learn.nn.maskfactory.MaskFactory.get_mask">
<code class="descname">get_mask</code><span class="sig-paren">(</span><em>df</em>, <em>output_mask</em>, <em>**kwargs</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/maskfactory.html#MaskFactory.get_mask"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.maskfactory.MaskFactory.get_mask" title="Permalink to this definition">¶</a></dt>
<dd><p>Analyzes data frame and output_mask, and returns an input mask</p>
<table class="docutils field-list" frame="void" rules="none">
<col class="field-name" />
<col class="field-body" />
<tbody valign="top">
<tr class="field-odd field"><th class="field-name">Parameters:</th><td class="field-body"><p class="first"><strong>df</strong> : pd.DataFrame</p>
<p><strong>outputMask</strong> : IndexMask</p>
<blockquote>
<div><p>Type is from clib/learn/nn/masks.py</p>
</div></blockquote>
</td>
</tr>
<tr class="field-even field"><th class="field-name">Returns:</th><td class="field-body"><p class="first"><strong>input_mask</strong> : IndexMask</p>
<blockquote class="last">
<div><p>From clib/learn/nn/masks.py</p>
</div></blockquote>
</td>
</tr>
</tbody>
</table>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn.masks">
<span id="d2o-learn-nn-masks-module"></span><h2>d2o.learn.nn.masks module<a class="headerlink" href="#module-d2o.learn.nn.masks" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.learn.nn.masks.IndexMask">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.masks.</code><code class="descname">IndexMask</code><span class="sig-paren">(</span><em>masks</em>, <em>name=None</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/masks.html#IndexMask"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.masks.IndexMask" title="Permalink to this definition">¶</a></dt>
<dd><p>Applied when creating a sliding window dataset</p>
<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMask.apply">
<code class="descname">apply</code><span class="sig-paren">(</span><em>df</em>, <em>index</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/masks.html#IndexMask.apply"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.masks.IndexMask.apply" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns a subset (pandas series.Series) per variable created by
applying the mask on the original dataframe for the given index</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMask.apply_serialize">
<code class="descname">apply_serialize</code><span class="sig-paren">(</span><em>df</em>, <em>index</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/masks.html#IndexMask.apply_serialize"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.masks.IndexMask.apply_serialize" title="Permalink to this definition">¶</a></dt>
<dd><p>Returns a serialized ([index], [values]) representation of the
masked dataframe</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMask.layout">
<code class="descname">layout</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/masks.html#IndexMask.layout"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.masks.IndexMask.layout" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="class">
<dt id="d2o.learn.nn.masks.IndexMaskTest">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.masks.</code><code class="descname">IndexMaskTest</code><span class="sig-paren">(</span><em>methodName='runTest'</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/masks.html#IndexMaskTest"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <code class="xref py py-class docutils literal"><span class="pre">unittest.case.TestCase</span></code></p>
<dl class="class">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime">
<em class="property">class </em><code class="descname">datetime</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/library/datetime.html#datetime.date" title="(in Python v2.7)"><code class="xref py py-class docutils literal"><span class="pre">datetime.date</span></code></a></p>
<p>The year, month and day arguments are required. tzinfo may be None, or an
instance of a tzinfo subclass. The remaining arguments may be ints or longs.</p>
<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.astimezone">
<code class="descname">astimezone</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.astimezone" title="Permalink to this definition">¶</a></dt>
<dd><p>tz -&gt; convert to local time in new timezone tz</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.combine">
<code class="descname">combine</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.combine" title="Permalink to this definition">¶</a></dt>
<dd><p>date, time -&gt; datetime with same date and time fields</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.ctime">
<code class="descname">ctime</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.ctime" title="Permalink to this definition">¶</a></dt>
<dd><p>Return ctime() style string.</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.date">
<code class="descname">date</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.date" title="Permalink to this definition">¶</a></dt>
<dd><p>Return date object with same year, month and day.</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.dst">
<code class="descname">dst</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.dst" title="Permalink to this definition">¶</a></dt>
<dd><p>Return self.tzinfo.dst(self).</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.fromtimestamp">
<code class="descname">fromtimestamp</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.fromtimestamp" title="Permalink to this definition">¶</a></dt>
<dd><p>timestamp[, tz] -&gt; tz&#8217;s local time from POSIX timestamp.</p>
</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.hour">
<code class="descname">hour</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.hour" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.isoformat">
<code class="descname">isoformat</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.isoformat" title="Permalink to this definition">¶</a></dt>
<dd><p>[sep] -&gt; string in ISO 8601 format, YYYY-MM-DDTHH:MM:SS[.mmmmmm][+HH:MM].</p>
<p>sep is used to separate the year from the time, and defaults to &#8216;T&#8217;.</p>
</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.max">
<code class="descname">max</code><em class="property"> = datetime.datetime(9999, 12, 31, 23, 59, 59, 999999)</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.max" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.microsecond">
<code class="descname">microsecond</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.microsecond" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.min">
<code class="descname">min</code><em class="property"> = datetime.datetime(1, 1, 1, 0, 0)</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.min" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.minute">
<code class="descname">minute</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.minute" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.now">
<code class="descname">now</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.now" title="Permalink to this definition">¶</a></dt>
<dd><p>[tz] -&gt; new datetime with tz&#8217;s local day and time.</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.replace">
<code class="descname">replace</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.replace" title="Permalink to this definition">¶</a></dt>
<dd><p>Return datetime with new specified fields.</p>
</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.resolution">
<code class="descname">resolution</code><em class="property"> = datetime.timedelta(0, 0, 1)</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.resolution" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.second">
<code class="descname">second</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.second" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.strptime">
<code class="descname">strptime</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.strptime" title="Permalink to this definition">¶</a></dt>
<dd><p>string, format -&gt; new datetime parsed from a string (like time.strptime()).</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.time">
<code class="descname">time</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.time" title="Permalink to this definition">¶</a></dt>
<dd><p>Return time object with same time but with tzinfo=None.</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.timetuple">
<code class="descname">timetuple</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.timetuple" title="Permalink to this definition">¶</a></dt>
<dd><p>Return time tuple, compatible with time.localtime().</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.timetz">
<code class="descname">timetz</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.timetz" title="Permalink to this definition">¶</a></dt>
<dd><p>Return time object with same time and tzinfo.</p>
</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.tzinfo">
<code class="descname">tzinfo</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.tzinfo" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.tzname">
<code class="descname">tzname</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.tzname" title="Permalink to this definition">¶</a></dt>
<dd><p>Return self.tzinfo.tzname(self).</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.utcfromtimestamp">
<code class="descname">utcfromtimestamp</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.utcfromtimestamp" title="Permalink to this definition">¶</a></dt>
<dd><p>timestamp -&gt; UTC datetime from a POSIX timestamp (like time.time()).</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.utcnow">
<code class="descname">utcnow</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.utcnow" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a new datetime representing UTC day and time.</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.utcoffset">
<code class="descname">utcoffset</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.utcoffset" title="Permalink to this definition">¶</a></dt>
<dd><p>Return self.tzinfo.utcoffset(self).</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.datetime.utctimetuple">
<code class="descname">utctimetuple</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.datetime.utctimetuple" title="Permalink to this definition">¶</a></dt>
<dd><p>Return UTC time tuple, compatible with time.localtime().</p>
</dd></dl>

</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.df">
<code class="descclassname">IndexMaskTest.</code><code class="descname">df</code><em class="property"> =             Restaurant  Total_RN  Total_RV 2000-01-01           0         0         0 2000-01-02           1         1         1 2000-01-03           2         2         2 2000-01-04           3         3         3 2000-01-05           4         4         4 2000-01-06           5         5         5 2000-01-07           6         6         6 2000-01-08           7         7         7 2000-01-09           8         8         8 2000-01-10           9         9         9 2000-01-11          10        10        10 2000-01-12          11        11        11 2000-01-13          12        12        12 2000-01-14          13        13        13 2000-01-15          14        14        14 2000-01-16          15        15        15 2000-01-17          16        16        16 2000-01-18          17        17        17 2000-01-19          18        18        18 2000-01-20          19        19        19 2000-01-21          20        20        20 2000-01-22          21        21        21 2000-01-23          22        22        22 2000-01-24          23        23        23 2000-01-25          24        24        24 2000-01-26          25        25        25 2000-01-27          26        26        26 2000-01-28          27        27        27 2000-01-29          28        28        28 2000-01-30          29        29        29 ...                ...       ...       ... 2002-08-28         970       970       970 2002-08-29         971       971       971 2002-08-30         972       972       972 2002-08-31         973       973       973 2002-09-01         974       974       974 2002-09-02         975       975       975 2002-09-03         976       976       976 2002-09-04         977       977       977 2002-09-05         978       978       978 2002-09-06         979       979       979 2002-09-07         980       980       980 2002-09-08         981       981       981 2002-09-09         982       982       982 2002-09-10         983       983       983 2002-09-11         984       984       984 2002-09-12         985       985       985 2002-09-13         986       986       986 2002-09-14         987       987       987 2002-09-15         988       988       988 2002-09-16         989       989       989 2002-09-17         990       990       990 2002-09-18         991       991       991 2002-09-19         992       992       992 2002-09-20         993       993       993 2002-09-21         994       994       994 2002-09-22         995       995       995 2002-09-23         996       996       996 2002-09-24         997       997       997 2002-09-25         998       998       998 2002-09-26         999       999       999  [1000 rows x 3 columns]</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.df" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.input_mask">
<code class="descclassname">IndexMaskTest.</code><code class="descname">input_mask</code><em class="property"> = [('Restaurant', -41, 0, 7), ('Restaurant', -365, -365, 1), ('Total_RN', -41, 0, 7), ('Total_RN', -365, -365, 1)]</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.input_mask" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.inputs">
<code class="descclassname">IndexMaskTest.</code><code class="descname">inputs</code><em class="property"> = [array([  0,  -6, -13, -20, -27, -34, -41]), array([-365])]</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.inputs" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.l">
<code class="descclassname">IndexMaskTest.</code><code class="descname">l</code><em class="property"> = [-365]</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.l" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.pd">
<code class="descclassname">IndexMaskTest.</code><code class="descname">pd</code><em class="property"> = &lt;module 'pandas' from '/usr/local/lib/python2.7/dist-packages/pandas/__init__.pyc'&gt;</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.pd" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.start_date">
<code class="descclassname">IndexMaskTest.</code><code class="descname">start_date</code><em class="property"> = datetime.datetime(2000, 1, 1, 0, 0)</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.start_date" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.target_mask">
<code class="descclassname">IndexMaskTest.</code><code class="descname">target_mask</code><em class="property"> = [('Restaurant', 6, 41, 6)]</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.target_mask" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.targets">
<code class="descclassname">IndexMaskTest.</code><code class="descname">targets</code><em class="property"> = [array([ 6, 13, 20, 27, 34, 41])]</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.targets" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.test_apply">
<code class="descclassname">IndexMaskTest.</code><code class="descname">test_apply</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/masks.html#IndexMaskTest.test_apply"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.test_apply" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.test_serialized">
<code class="descclassname">IndexMaskTest.</code><code class="descname">test_serialized</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/masks.html#IndexMaskTest.test_serialized"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.test_serialized" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="class">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta">
<em class="property">class </em><code class="descclassname">IndexMaskTest.</code><code class="descname">timedelta</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/library/functions.html#object" title="(in Python v2.7)"><code class="xref py py-class docutils literal"><span class="pre">object</span></code></a></p>
<p>Difference between two datetime values.</p>
<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta.days">
<code class="descname">days</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta.days" title="Permalink to this definition">¶</a></dt>
<dd><p>Number of days.</p>
</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta.max">
<code class="descname">max</code><em class="property"> = datetime.timedelta(999999999, 86399, 999999)</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta.max" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta.microseconds">
<code class="descname">microseconds</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta.microseconds" title="Permalink to this definition">¶</a></dt>
<dd><p>Number of microseconds (&gt;= 0 and less than 1 second).</p>
</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta.min">
<code class="descname">min</code><em class="property"> = datetime.timedelta(-999999999)</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta.min" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta.resolution">
<code class="descname">resolution</code><em class="property"> = datetime.timedelta(0, 0, 1)</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta.resolution" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta.seconds">
<code class="descname">seconds</code><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta.seconds" title="Permalink to this definition">¶</a></dt>
<dd><p>Number of seconds (&gt;= 0 and less than 1 day).</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.masks.IndexMaskTest.timedelta.total_seconds">
<code class="descname">total_seconds</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.timedelta.total_seconds" title="Permalink to this definition">¶</a></dt>
<dd><p>Total seconds in the duration.</p>
</dd></dl>

</dd></dl>

<dl class="attribute">
<dt id="d2o.learn.nn.masks.IndexMaskTest.x">
<code class="descclassname">IndexMaskTest.</code><code class="descname">x</code><em class="property"> = 999</em><a class="headerlink" href="#d2o.learn.nn.masks.IndexMaskTest.x" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn.runner">
<span id="d2o-learn-nn-runner-module"></span><h2>d2o.learn.nn.runner module<a class="headerlink" href="#module-d2o.learn.nn.runner" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.learn.nn.runner.Runner">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.runner.</code><code class="descname">Runner</code><span class="sig-paren">(</span><em>network</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/runner.html#Runner"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.runner.Runner" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="d2o.learn.nn.runner.Runner.run">
<code class="descname">run</code><span class="sig-paren">(</span><em>dataset</em>, <em>scale=True</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/runner.html#Runner.run"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.runner.Runner.run" title="Permalink to this definition">¶</a></dt>
<dd><p>Per row index:[inputs] for the neural network
Creates a index:[outputs] result set after running through every row</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.runner.Runner.serialize">
<code class="descname">serialize</code><span class="sig-paren">(</span><em>results</em>, <em>descriptors</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/runner.html#Runner.serialize"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.runner.Runner.serialize" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn.trainer">
<span id="d2o-learn-nn-trainer-module"></span><h2>d2o.learn.nn.trainer module<a class="headerlink" href="#module-d2o.learn.nn.trainer" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="d2o.learn.nn.trainer.Trainer">
<em class="property">class </em><code class="descclassname">d2o.learn.nn.trainer.</code><code class="descname">Trainer</code><span class="sig-paren">(</span><em>network</em>, <em>dataset</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/trainer.html#Trainer"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.trainer.Trainer" title="Permalink to this definition">¶</a></dt>
<dd><p>Trains the neural network on the supplied dataset</p>
<dl class="method">
<dt id="d2o.learn.nn.trainer.Trainer.train_epochs">
<code class="descname">train_epochs</code><span class="sig-paren">(</span><em>epochs=5000</em>, <em>learning_rate=0.009</em>, <em>momentum=0.5</em>, <em>update_rate=10</em>, <em>min_err=0.001</em>, <em>plot=False</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/trainer.html#Trainer.train_epochs"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.trainer.Trainer.train_epochs" title="Permalink to this definition">¶</a></dt>
<dd><p>Train network for the chosen number of epochs.
:param epochs: Number of epochs to train for
:param learning_rate: Network learning rate
:param momentum: Network learning momentum
:param update_rate: Update plots and logging every update_rate tick
:param min_err: Termination error
:param plot: Create and update plots during training, default=False
:returns: Trained network</p>
</dd></dl>

<dl class="method">
<dt id="d2o.learn.nn.trainer.Trainer.train_epochs_test">
<code class="descname">train_epochs_test</code><span class="sig-paren">(</span><em>epochs=5000</em>, <em>learning_rate=0.009</em>, <em>momentum=0.5</em>, <em>update_rate=10</em>, <em>min_err=0.001</em>, <em>plot=True</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/trainer.html#Trainer.train_epochs_test"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.trainer.Trainer.train_epochs_test" title="Permalink to this definition">¶</a></dt>
<dd><p>Used for testing. Contains plotting functionality</p>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn.transfer_functions">
<span id="d2o-learn-nn-transfer-functions-module"></span><h2>d2o.learn.nn.transfer_functions module<a class="headerlink" href="#module-d2o.learn.nn.transfer_functions" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.gaussian">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">gaussian</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#gaussian"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.gaussian" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.gaussian_derivative">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">gaussian_derivative</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#gaussian_derivative"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.gaussian_derivative" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.linear">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">linear</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#linear"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.linear" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.linear_derivative">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">linear_derivative</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#linear_derivative"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.linear_derivative" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.sigmoid">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">sigmoid</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#sigmoid"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.sigmoid" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.sigmoid_derivative">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">sigmoid_derivative</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#sigmoid_derivative"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.sigmoid_derivative" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.tanh">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">tanh</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#tanh"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.tanh" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="d2o.learn.nn.transfer_functions.tanh_derivative">
<code class="descclassname">d2o.learn.nn.transfer_functions.</code><code class="descname">tanh_derivative</code><span class="sig-paren">(</span><em>x</em><span class="sig-paren">)</span><a class="reference internal" href="_modules/d2o/learn/nn/transfer_functions.html#tanh_derivative"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#d2o.learn.nn.transfer_functions.tanh_derivative" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
<div class="section" id="module-d2o.learn.nn">
<span id="module-contents"></span><h2>Module contents<a class="headerlink" href="#module-d2o.learn.nn" title="Permalink to this headline">¶</a></h2>
</div>
</div>


           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'./',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="_static/jquery.js"></script>
      <script type="text/javascript" src="_static/underscore.js"></script>
      <script type="text/javascript" src="_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>